<template>
    <div v-if="loading">Loading...</div>
    <div v-if="!loading && dog">
      <h1>{{ dog.name }} <i class="bi bi-pencil-square" @click="editing = !editing"></i></h1>
      <div v-if="!editing">
        <p>{{ dog.breed }}</p>
        <p>{{ dog.birthdate }}</p>
      </div>
      <DogForm v-if="editing" :initial-dog="dog" @submit="handleSubmit($event)" />
      <button class="btn btn-danger" @click="handleDelete()">Delete</button>
    </div>
</template>

<script setup lang="ts">
import {  fetchOneDog } from '@/dog-service';
import type { Dog } from '@/entities';
import { ref,  watch } from 'vue';
import {  useRoute, useRouter } from 'vue-router';
import {deleteDog, updateDog} from '../dog-service'
import DogForm from '@/components/DogForm.vue';

const route = useRoute();
const dog = ref<Dog>();
//Une ref qui indique que les données sont en cours de chargement
const loading = ref(true);
const router = useRouter();

const editing = ref(false);

watch(() => route.params.id, async () => {
  dog.value = await fetchOneDog(route.params.id);
  loading.value = false;
}, {immediate:true});

async function handleDelete() {
  await deleteDog(dog.value?.id);
  router.push('/');
}

async function handleSubmit(updated:Dog) {
 await updateDog(updated);
 dog.value = updated;
 editing.value = false;
}

</script>